// DisasmViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DisasmViewer.h"
#include "DisasmViewerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////
// XP Style Common Controls
#pragma comment(linker, "/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisasmViewerDlg dialog

CDisasmViewerDlg::CDisasmViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisasmViewerDlg::IDD, pParent)
	, m_bDisassembleCodeOnly(FALSE)
	, m_nBytesPerLine(16)
	, m_bMakeAssembleUpper(FALSE)
	, m_nStripOffset(32)
	, m_strInitialOffset(_T("00000000"))
	, m_strBinaryOffset(_T("00000000"))
{
	//{{AFX_DATA_INIT(CDisasmViewerDlg)
	m_strOpcode = _T("");
	m_strDisassemble = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisasmViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDisasmViewerDlg)
	DDX_Text(pDX, IDC_EDIT_BINARY, m_strOpcode);
	DDX_Text(pDX, IDC_EDIT_DISASM, m_strDisassemble);
	DDX_Check(pDX, IDC_CHECK_ONLY_DISASSEM_CODE, m_bDisassembleCodeOnly);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT_BYTES_PER_LINE, m_nBytesPerLine);
	DDV_MinMaxInt(pDX, m_nBytesPerLine, 1, 1000);
	DDX_Check(pDX, IDC_CHECK_UPPER, m_bMakeAssembleUpper);
	DDX_Control(pDX, IDC_LOG_LIST, m_listStatus);
	DDX_Text(pDX, IDC_EDIT_STRIP_OFFSET, m_nStripOffset);
	DDV_MinMaxInt(pDX, m_nStripOffset, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_INITIAL_OFFSET, m_strInitialOffset);
	DDX_Text(pDX, IDC_EDIT_BINARY_OFFSET, m_strBinaryOffset);
}

BEGIN_MESSAGE_MAP(CDisasmViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CDisasmViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_OPEN, &CDisasmViewerDlg::OnBnClickedButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_AS_BINARY, &CDisasmViewerDlg::OnBnClickedButtonSaveAsBinary)
	ON_BN_CLICKED(IDC_BUTTON_ASSEMBLE, &CDisasmViewerDlg::OnBnClickedButtonAssem)
	ON_BN_CLICKED(IDC_BUTTON_DISASSEMBLE, &CDisasmViewerDlg::OnBnClickedButtonDisassemble)
	ON_BN_CLICKED(IDC_RADIO_LIBDASM, &CDisasmViewerDlg::OnBnClickedRadioLibdasm)
	ON_BN_CLICKED(IDC_RADIO_DISTDASM, &CDisasmViewerDlg::OnBnClickedRadioDistdasm)
	ON_BN_CLICKED(IDC_RADIO_DISASMENGINE, &CDisasmViewerDlg::OnBnClickedRadioDisasmengine)
	ON_BN_CLICKED(IDC_RADIO_ASSEMBLE_SHELLCODE, &CDisasmViewerDlg::OnBnClickedRadioAssembleShellcode)
	ON_BN_CLICKED(IDC_RADIO_ASSEMBLE_HEX_NOSPACE, &CDisasmViewerDlg::OnBnClickedRadioAssembleHexNospace)
	ON_BN_CLICKED(IDC_RADIO_ASSEMBLE_HEX_SPACE, &CDisasmViewerDlg::OnBnClickedRadioAssembleHexSpace)
	ON_BN_CLICKED(IDC_BUTTON_STRIP_DISASSEMBLE, &CDisasmViewerDlg::OnBnClickedButtonStripDisassemble)
	ON_BN_CLICKED(IDC_BUTTON_RELOAD, &CDisasmViewerDlg::OnBnClickedButtonReload)
	ON_BN_CLICKED(IDM_ABOUTBOX, &CDisasmViewerDlg::OnBnClickedAboutbox)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisasmViewerDlg message handlers

CDisasmViewerDlg::~CDisasmViewerDlg()
{
	delete m_font;
}

void CDisasmViewerDlg::OnClose()
{

}

void CDisasmViewerDlg::OnOK()
{

}

BOOL CDisasmViewerDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && GetKeyState(VK_CONTROL) < 0)
	{
		DWORD def_id = GetDefID();
		if (def_id != 0)
		{
			CWnd *pWnd = FromHandle(pMsg->hwnd);
			char class_name[16];
			if (GetClassName(pWnd->GetSafeHwnd(), class_name, sizeof(class_name)) != 0)
			{
				if (_strnicmp(class_name, "edit", 5) == 0)
				{
					switch(pMsg->wParam)
					{
					case 'A':
						((CEdit*)pWnd)->SetSel(0, ((CEdit*)pWnd)->GetWindowTextLength());
						return TRUE;	
					case 'C':
						((CEdit*)pWnd)->Copy();
						return TRUE;
					case 'V':
						((CEdit*)pWnd)->Paste();
						return TRUE;
					case 'X':
						((CEdit*)pWnd)->Cut();
						return TRUE;
					}
				}
			}
		}
	}


	//////////////////////////////////////////////////////////////////////////
	// Accelerators!
	//////////////////////////////////////////////////////////////////////////

	else if ((pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN)&& GetKeyState(VK_LMENU) < 0)
	{
		switch(pMsg->wParam)
		{
		case 'O': // Open
			OnBnClickedButtonOpen();
			return TRUE;
		case 'R': // Reload
			OnBnClickedButtonReload();
			return TRUE;
		case 'S': // Save as
			OnBnClickedButtonSaveAsBinary();
			return TRUE;
		case 'D': // Disassemble
			OnBnClickedButtonDisassemble();
			return TRUE;
		case 'A': // Assemble
			OnBnClickedButtonAssem();
			return TRUE;
		case 'T': // Strip Genius
			OnBnClickedButtonStripDisassemble();
			return TRUE;
		case '1': // Set focus on Opcodes edit control
			GetDlgItem(IDC_EDIT_BINARY)->SetFocus();
			return TRUE;
		case '2': // Set focus on Disassemble edit control
			GetDlgItem(IDC_EDIT_DISASM)->SetFocus();
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CDisasmViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitCommonControls();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_font = new CFont();
	m_font->CreateFont( 12,                        // nHeight
		0,                         // nWidth
		0,                         // nEscapement
		0,                         // nOrientation
		FW_NORMAL,                 // nWeight
		FALSE,                     // bItalic
		FALSE,                     // bUnderline
		0,                         // cStrikeOut
		ANSI_CHARSET,              // nCharSet
		OUT_DEFAULT_PRECIS,        // nOutPrecision
		CLIP_DEFAULT_PRECIS,       // nClipPrecision
		DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
		_T("Lucida Console"));                 // lpszFacename

	GetDlgItem(IDC_EDIT_BINARY)->SetFont(m_font);
	GetDlgItem(IDC_EDIT_DISASM)->SetFont(m_font);

	((CButton*)GetDlgItem(IDC_RADIO_LIBDASM))->SetCheck(BST_CHECKED);
	m_DisasmMode = DISASSEMBLE_LIBDASM;

	((CButton*)GetDlgItem(IDC_RADIO_ASSEMBLE_SHELLCODE))->SetCheck(BST_CHECKED);
	m_AssemMode = ASSEMBLE_SHELLCODE;

	DWORD style = m_listStatus.GetExtendedStyle();
	m_listStatus.SetExtendedStyle(style | LVS_EX_GRIDLINES | LVS_EX_INFOTIP | LVS_EX_LABELTIP );
	m_listStatus.InsertColumn(0, "Time", LVCFMT_LEFT, 90);
	m_listStatus.InsertColumn(1, "Event", LVCFMT_LEFT, 700);
	m_imagelist.Create(16,16, ILC_COLOR32, 1, 1);
	m_imagelist.Add(AfxGetApp()->LoadIcon(IDI_LOG));
	m_listStatus.SetImageList(&m_imagelist, LVSIL_SMALL);

	CTime timeCurrent = CTime::GetCurrentTime();
	CTime timeCreated = CTime(timeCurrent.GetYear() - 2, timeCurrent.GetMonth(), timeCurrent.GetDay(), timeCurrent.GetHour(), timeCurrent.GetMinute(), timeCurrent.GetMinute());

	m_timeCreated = timeCreated;

	GetWindowText(m_strProgramTitle);
	SetWindowText(m_strProgramTitle + "- No file opened");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDisasmViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDisasmViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDisasmViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Windows message pumping
void CDisasmViewerDlg::PumpMessage(HWND hWnd)
{
	MSG msg;

	while (PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE)) 
	{
		if (!::IsDialogMessage(hWnd, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
}

void CDisasmViewerDlg::OnBnClickedButtonOpen()
{
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	TCHAR szFilters[]= _T("EXE Files (*.exe)|*.exe|BIN File (*.bin)|*.bin|All Files (*.*)|*.*||");

	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("exe"), _T("*.exe"),
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	if (fileDlg.DoModal() == IDOK)
	{
		Disassemble(fileDlg.GetPathName());
	}
}

void CDisasmViewerDlg::OnBnClickedButtonSaveAsBinary()
{
	// Opcode  Binary Ѵ.
	//
	UpdateData(TRUE);
	BYTE *byteBinary = (BYTE*) malloc (sizeof(BYTE) * m_strOpcode.GetLength());

	if (byteBinary == NULL)
		return;

	int nSize = m_disasm.OpcodeToBinary(m_strOpcode, byteBinary);

	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	TCHAR szFilters[]= _T("EXE Files (*.exe)|*.exe|BIN File (*.bin)|*.bin|All Files (*.*)|*.*||");

	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(FALSE, _T("exe"), _T("*.exe"),
		OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY, szFilters);

	if (fileDlg.DoModal() == IDOK)
	{
		UpdateData(TRUE);

		CString filename = fileDlg.GetPathName();

		HANDLE file = NULL;
		file = CreateFile(filename, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (file == INVALID_HANDLE_VALUE) { 
			CString str;
			str.Format("Could not create file %s (error %d)\n", filename, GetLastError());
			_ShowJobStatus(str);
			return;
		}

		// We read the whole file into memory in order to make life easier,
		// otherwise we would have to synchronize the code buffer as well (so instructions won't be split).
		DWORD byteswrite = 0;
		if (!WriteFile(file, byteBinary, nSize, &byteswrite, NULL)) {
			CString str;
			str.Format("Error creating file (error %d)\n", GetLastError());
			_ShowJobStatus(str);
			CloseHandle(file);
			return;
		}

		CloseHandle(file);	

		CString str;
		str.Format("%d bytes are saved as %s file", byteswrite, filename);
		_ShowJobStatus(str);
	}

	free(byteBinary);
}

void CDisasmViewerDlg::OnBnClickedButtonAssem()
{
	Assemble();
}

void CDisasmViewerDlg::OnBnClickedButtonDisassemble()
{
	_ShowJobStatus("Disassembling is started");
	
	UpdateData(TRUE);
	
	DWORD nInitialOffset = m_disasm.HexToLong(m_strInitialOffset);
	int nSize = m_disasm.Disasm(m_strOpcode, m_strDisassemble, m_DisasmMode, m_bDisassembleCodeOnly, nInitialOffset);

	if (nSize == -1)
	{
		_ShowJobStatus("Disassembling is failed");
	}
	else
	{
		CString str;
		str.Format("Total %dbytes are disassembled", nSize);
		_ShowJobStatus(str);
	}

	UpdateData(FALSE);	
}

void CDisasmViewerDlg::OnBnClickedRadioLibdasm()
{
	m_DisasmMode = DISASSEMBLE_LIBDASM;
}

void CDisasmViewerDlg::OnBnClickedRadioDistdasm()
{
	m_DisasmMode = DISASSEMBLE_DISTDASM;
}

void CDisasmViewerDlg::OnBnClickedRadioDisasmengine()
{
	m_DisasmMode = DISASSEMBLE_DISASMENGINE;
}

void CDisasmViewerDlg::OnBnClickedRadioAssembleShellcode()
{
	m_AssemMode = ASSEMBLE_SHELLCODE;
}

void CDisasmViewerDlg::OnBnClickedRadioAssembleHexNospace()
{
	m_AssemMode = ASSEMBLE_HEX_NOSPACE;
}

void CDisasmViewerDlg::OnBnClickedRadioAssembleHexSpace()
{
	m_AssemMode = ASSEMBLE_HEX_SPACE;
}


void CDisasmViewerDlg::_ShowJobStatus(const CString & str)
{
	int pos = m_listStatus.GetItemCount();
	CTime t = CTime::GetCurrentTime();
	CString s = t.Format(" %H:%M:%S");
	m_listStatus.InsertItem(pos, s, 0);
	m_listStatus.SetItemText(pos, 1, str);
	m_listStatus.EnsureVisible(pos, FALSE);

	PumpMessage(m_hWnd);
}

void CDisasmViewerDlg::Disassemble(CString filename)
{
	UpdateData(TRUE);

	HANDLE file = NULL;
	file = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (file == INVALID_HANDLE_VALUE) { 
		printf("Could not open file %s (error %d)\n", filename, GetLastError());
		return;
	}

	DWORD filesize = 0;
	if ((filesize = GetFileSize(file, NULL)) < 0) {
		printf("Error getting filesize (error %d)\n", GetLastError());
		CloseHandle(file);
		return;
	}

	// We read the whole file into memory in order to make life easier,
	// otherwise we would have to synchronize the code buffer as well (so instructions won't be split).
	unsigned char * buf2 = NULL;
	unsigned char * buf = NULL;
	buf2 = buf = (unsigned char*)malloc(filesize);
	DWORD bytesread = 0;
	if (!ReadFile(file, buf, filesize, &bytesread, NULL)) {
		printf("Error reading file (error %d)\n", GetLastError());
		CloseHandle(file);
		free(buf);
		return;
	}

	if (filesize != bytesread) {
		printf("Internal read-error in system\n");
		CloseHandle(file);
		free(buf);
		return;
	}

	CloseHandle(file);	

	_ShowJobStatus("Disassembling is started");

	DWORD nBinaryOffset = m_disasm.HexToLong(m_strBinaryOffset);
	if(nBinaryOffset >= bytesread)
	{
		CString str;
		str.Format("Out of bound: offset 0x%x >= the file size 0x%x", nBinaryOffset, bytesread);
		_ShowJobStatus(str);		
		return;
	}
	bytesread -= nBinaryOffset;
	m_strOpcode = m_disasm.BinaryToOpcode(&buf[nBinaryOffset], bytesread, m_nBytesPerLine, m_AssemMode, m_bMakeAssembleUpper);

	DWORD nInitialOffset = m_disasm.HexToLong(m_strInitialOffset);
	int nSize = m_disasm.Disasm(m_strOpcode, m_strDisassemble, m_DisasmMode, m_bDisassembleCodeOnly, nInitialOffset);

	if (nSize == -1)
	{
		_ShowJobStatus("Disassembling is failed");
	}
	else
	{
		CString str;
		str.Format("Total %d bytes of %s file are disassembled", nSize, filename);
		_ShowJobStatus(str);
	}

	m_strLoadedFileName = filename;
	SetWindowText(m_strProgramTitle + "- " + m_strLoadedFileName);

	UpdateData(FALSE);
}

void CDisasmViewerDlg::Assemble()
{
	UpdateData(TRUE);

	CStringArray arrDisassem;
	CString strDisassem = m_strDisassemble;
	strDisassem.Trim();
	int nFirst = 0;
	int nPos = 0;
	while ((nPos = strDisassem.Find("\r\n", nFirst)) != -1)
	{
		arrDisassem.Add(strDisassem.Mid(nFirst, nPos - nFirst));
		nFirst = nPos + 2;
	}

	if (nFirst < strDisassem.GetLength())
	{
		arrDisassem.Add(strDisassem.Mid(nFirst, strDisassem.GetLength() - nFirst));

	}

	BYTE *byteAssem = (BYTE*) malloc(sizeof(BYTE) * strDisassem.GetLength());

	int nSize = m_disasm.Assem(arrDisassem, byteAssem);

	m_strOpcode = m_disasm.BinaryToOpcode(byteAssem, nSize, m_nBytesPerLine, m_AssemMode, m_bMakeAssembleUpper);

	CString str;
	str.Format("Total %dbytes are assembled", nSize);
	_ShowJobStatus(str);

	free(byteAssem);

	UpdateData(FALSE);	

}
void CDisasmViewerDlg::OnBnClickedButtonStripDisassemble()
{
	// ° ̳ʸ ڵ尡 Բ ִ Disassemble ڵκ
	//  ڵ常 Ѵ.
	//

	//////////////////////////////////////////////////////////////////////////
	// Warning!!!
	MessageBox("Strip Genius is not perfect.\nUse it on your own risk.", "Warning", MB_ICONWARNING);

	UpdateData(TRUE);

	CStringArray arrDisassem;
	CString strDisassem = m_strDisassemble;
	strDisassem.Trim();
	int nFirst = 0;
	int nPos = 0;
	while ((nPos = strDisassem.Find("\r\n", nFirst)) != -1)
	{
		arrDisassem.Add(strDisassem.Mid(nFirst, nPos - nFirst).Mid(m_nStripOffset));
		nFirst = nPos + 2;
	}

	if (nFirst < strDisassem.GetLength())
	{
		arrDisassem.Add(strDisassem.Mid(nFirst, strDisassem.GetLength() - nFirst).Mid(m_nStripOffset));

	}

	m_strDisassemble.Empty();
	int nLine = arrDisassem.GetCount();
	for (int i = 0; i < nLine; i++)
	{
		m_strDisassemble += arrDisassem.GetAt(i);
		m_strDisassemble += "\r\n";
	}

	UpdateData(FALSE);
}

void CDisasmViewerDlg::OnBnClickedButtonReload()
{
	if (m_strLoadedFileName.GetLength() != 0)
	{
		Disassemble(m_strLoadedFileName);
	}
}


void CDisasmViewerDlg::OnBnClickedAboutbox()
{
	CAboutDlg dlg;
	dlg.DoModal();
}
