// DisasmViewerDlg.h : header file
//

#if !defined(AFX_DISASMVIEWERDLG_H__0E9B6120_E961_407E_B2A1_89F2D8C634F5__INCLUDED_)
#define AFX_DISASMVIEWERDLG_H__0E9B6120_E961_407E_B2A1_89F2D8C634F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "disasm/DisasmFactory.h"
#include "afxcmn.h"

/////////////////////////////////////////////////////////////////////////////
// CDisasmViewerDlg dialog

class CDisasmViewerDlg : public CDialog
{
// Construction
public:
	CDisasmViewerDlg(CWnd* pParent = NULL);	// standard constructor
	~CDisasmViewerDlg();

// Dialog Data
	//{{AFX_DATA(CDisasmViewerDlg)
	enum { IDD = IDD_DISASMVIEWER_DIALOG };
	CString	m_strOpcode;
	CString m_strDisassemble;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDisasmViewerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void OnClose();
	virtual void OnOK();

	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDisasmViewerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	CDisasmFactory m_disasm;
	CFont *m_font;
	int m_DisasmMode;
	int m_AssemMode;

public:
	afx_msg void OnBnClickedButtonOpen();
	afx_msg void OnBnClickedButtonSaveAsBinary();
	afx_msg void OnBnClickedButtonAssem();

	// ּҿ   ڵ常 
	BOOL m_bDisassembleCodeOnly;

	afx_msg void OnBnClickedButtonDisassemble();
	afx_msg void OnBnClickedRadioLibdasm();
	afx_msg void OnBnClickedRadioDistdasm();
	afx_msg void OnBnClickedRadioDisasmengine();
	afx_msg void OnBnClickedRadioAssembleShellcode();
	afx_msg void OnBnClickedRadioAssembleHexNospace();
	afx_msg void OnBnClickedRadioAssembleHexSpace();

	int m_nBytesPerLine;
	BOOL m_bMakeAssembleUpper;

	CListCtrl m_listStatus;
	CImageList m_imagelist;
	CTime m_timeCreated;

	CString m_strLoadedFileName;
	CString m_strProgramTitle;

private:
	void PumpMessage(HWND hWnd);
	void _ShowJobStatus(const CString & str);

	void Disassemble(CString filename);
	void Assemble();

public:
	afx_msg void OnBnClickedButtonStripDisassemble();
	int m_nStripOffset;
	afx_msg void OnBnClickedButtonReload();
	CString m_strInitialOffset;
	CString m_strBinaryOffset;
	afx_msg void OnBnClickedAboutbox();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISASMVIEWERDLG_H__0E9B6120_E961_407E_B2A1_89F2D8C634F5__INCLUDED_)
