// CDisasmFactory.h: interface for the CDisasm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DISASM_H__A5F25EE9_FF56_43E2_A67E_92F4689250D8__INCLUDED_)
#define AFX_DISASM_H__A5F25EE9_FF56_43E2_A67E_92F4689250D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "defines.h"

class CDisasmFactory  
{
public:
	CDisasmFactory();
	virtual ~CDisasmFactory();

protected:
	//////////////////////////////////////////////////////////////////////////
	// Used in ConvertLibdasm() method
	//////////////////////////////////////////////////////////////////////////
	void ShowDecoded(DISASSEMBLY Disasm, CString &strDecoded);
	void FlushDecoded(DISASSEMBLY *Disasm);

	int ConvertLibdasm(CString &strOpcode, CString &strDisasm, BOOL bCodeOnly = FALSE, DWORD nInitialAddress = 0);
	int ConvertDisasmEngine(CString &strOpcode, CString &strDisasm, BOOL bCodeOnly = FALSE, DWORD nInitialAddress = 0);
	int ConvertDistasmEngine(CString &strOpcode, CString &strDisasm, BOOL bCodeOnly = FALSE, DWORD nInitialAddress = 0);

public:
	CString BinaryToOpcode(BYTE *byteBinary, int nSize, int nLineLength, int nMode = ASSEMBLE_SHELLCODE, int bMakeAssembleUpper = FALSE);
	int OpcodeToBinary(CString strOpcode, BYTE *byteBinary);

	int Disasm(CString &strOpcode, CString &strDisasm, int nMode = DISASSEMBLE_LIBDASM, BOOL bCodeOnly = FALSE, DWORD nInitialAddress = 0);
	int Assem(CStringArray &arrAsm, BYTE *byteBinary);

	long HexToLong(CString &szHexValue);

};

#endif // !defined(AFX_DISASM_H__A5F25EE9_FF56_43E2_A67E_92F4689250D8__INCLUDED_)
