#ifndef DISASM_DEFINES_DEFINED
#define DISASM_DEFINES_DEFINED

#define MIN(x, y) ((x) < (y) ? (x) : (y))

//////////////////////////////////////////////////////////////////////////
//                        TYPE DEFINES                                  //
//////////////////////////////////////////////////////////////////////////

typedef struct Decoded{
	
	// Define Decoded instruction struct
	
    char Assembly[256]; // Menemonics
    char Remarks[256];  // Menemonic addons
    char Opcode[30];    // Opcode Byte forms
    DWORD Address;      // Current address of decoded instruction
    BYTE  OpcodeSize;   // Opcode Size
	BYTE  PrefixSize;   // Size of all prefixes used
	
} DISASSEMBLY;

typedef void (*DISASM_FUNCTION)(DISASSEMBLY*,char*,DWORD*);

//////////////////////////////////////////////////////////////////////////
//                             DEFINES                                  //
//////////////////////////////////////////////////////////////////////////
#define BYTES_TO_DECODE 16

// The number of the array of instructions the decoder function will use to return the disassembled instructions.
// Play with this value for performance...
#define MAX_INSTRUCTIONS (1000)


//////////////////////////////////////////////////////////////////////////
//                           Opcode Type                                //
//////////////////////////////////////////////////////////////////////////

// Following tools are also included
// - WinHex
#define OPCODE_GENERIC				0	// 0873... or 08 73...

#define OPCODE_SHELLCODE			1	// \x08\x73....
#define OPCODE_FROM_FRHED			2	// <bh:08><bh:73>...

#endif

//////////////////////////////////////////////////////////////////////////
//                           Disassemble Mode                           //
//////////////////////////////////////////////////////////////////////////
#define DISASSEMBLE_LIBDASM			1
#define DISASSEMBLE_DISTDASM		2
#define DISASSEMBLE_DISASMENGINE	3

//////////////////////////////////////////////////////////////////////////
//                           Assemble Mode                              //
//////////////////////////////////////////////////////////////////////////
#define ASSEMBLE_SHELLCODE			1
#define ASSEMBLE_HEX_NOSPACE		2
#define ASSEMBLE_HEX_SPACE			3


//////////////////////////////////////////////////////////////////////////
// TODO LIST
//
// - EXE  εϴ  ڵ Ʈ Ʈ ãֱ
// -  Opcode νϱ (IDA, OllyDbg )
// - ޸   ϱ
// - ͸ ε   Ͽ ε  ֵ ϱ
// - ε